# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Spanner.V1.Model.AutoscalingTargets do
  @moduledoc """
  The autoscaling targets for an instance.

  ## Attributes

  *   `highPriorityCpuUtilizationPercent` (*type:* `integer()`, *default:* `nil`) - Required. The target high priority cpu utilization percentage that the autoscaler should be trying to achieve for the instance. This number is on a scale from 0 (no utilization) to 100 (full utilization). The valid range is [10, 90] inclusive.
  *   `storageUtilizationPercent` (*type:* `integer()`, *default:* `nil`) - Required. The target storage utilization percentage that the autoscaler should be trying to achieve for the instance. This number is on a scale from 0 (no utilization) to 100 (full utilization). The valid range is [10, 99] inclusive.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :highPriorityCpuUtilizationPercent => integer() | nil,
          :storageUtilizationPercent => integer() | nil
        }

  field(:highPriorityCpuUtilizationPercent)
  field(:storageUtilizationPercent)
end

defimpl Poison.Decoder, for: GoogleApi.Spanner.V1.Model.AutoscalingTargets do
  def decode(value, options) do
    GoogleApi.Spanner.V1.Model.AutoscalingTargets.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Spanner.V1.Model.AutoscalingTargets do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
