# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Spanner.V1.Model.BackupInfo do
  @moduledoc """
  Information about a backup.

  ## Attributes

  *   `backup` (*type:* `String.t`, *default:* `nil`) - Name of the backup.
  *   `createTime` (*type:* `DateTime.t`, *default:* `nil`) - The time the CreateBackup request was received.
  *   `sourceDatabase` (*type:* `String.t`, *default:* `nil`) - Name of the database the backup was created from.
  *   `versionTime` (*type:* `DateTime.t`, *default:* `nil`) - The backup contains an externally consistent copy of `source_database` at the timestamp specified by `version_time`. If the CreateBackup request did not specify `version_time`, the `version_time` of the backup is equivalent to the `create_time`.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :backup => String.t() | nil,
          :createTime => DateTime.t() | nil,
          :sourceDatabase => String.t() | nil,
          :versionTime => DateTime.t() | nil
        }

  field(:backup)
  field(:createTime, as: DateTime)
  field(:sourceDatabase)
  field(:versionTime, as: DateTime)
end

defimpl Poison.Decoder, for: GoogleApi.Spanner.V1.Model.BackupInfo do
  def decode(value, options) do
    GoogleApi.Spanner.V1.Model.BackupInfo.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Spanner.V1.Model.BackupInfo do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
