# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Spanner.V1.Model.ContextValue do
  @moduledoc """
  A message representing context for a KeyRangeInfo, including a label, value, unit, and severity.

  ## Attributes

  *   `label` (*type:* `GoogleApi.Spanner.V1.Model.LocalizedString.t`, *default:* `nil`) - The label for the context value. e.g. "latency".
  *   `severity` (*type:* `String.t`, *default:* `nil`) - The severity of this context.
  *   `unit` (*type:* `String.t`, *default:* `nil`) - The unit of the context value.
  *   `value` (*type:* `number()`, *default:* `nil`) - The value for the context.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :label => GoogleApi.Spanner.V1.Model.LocalizedString.t() | nil,
          :severity => String.t() | nil,
          :unit => String.t() | nil,
          :value => number() | nil
        }

  field(:label, as: GoogleApi.Spanner.V1.Model.LocalizedString)
  field(:severity)
  field(:unit)
  field(:value)
end

defimpl Poison.Decoder, for: GoogleApi.Spanner.V1.Model.ContextValue do
  def decode(value, options) do
    GoogleApi.Spanner.V1.Model.ContextValue.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Spanner.V1.Model.ContextValue do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
