# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Spanner.V1.Model.Delete do
  @moduledoc """
  Arguments to delete operations.

  ## Attributes

  *   `keySet` (*type:* `GoogleApi.Spanner.V1.Model.KeySet.t`, *default:* `nil`) - Required. The primary keys of the rows within table to delete. The primary keys must be specified in the order in which they appear in the `PRIMARY KEY()` clause of the table's equivalent DDL statement (the DDL statement used to create the table). Delete is idempotent. The transaction will succeed even if some or all rows do not exist.
  *   `table` (*type:* `String.t`, *default:* `nil`) - Required. The table whose rows will be deleted.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :keySet => GoogleApi.Spanner.V1.Model.KeySet.t() | nil,
          :table => String.t() | nil
        }

  field(:keySet, as: GoogleApi.Spanner.V1.Model.KeySet)
  field(:table)
end

defimpl Poison.Decoder, for: GoogleApi.Spanner.V1.Model.Delete do
  def decode(value, options) do
    GoogleApi.Spanner.V1.Model.Delete.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Spanner.V1.Model.Delete do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
