# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Spanner.V1.Model.DerivedMetric do
  @moduledoc """
  A message representing a derived metric.

  ## Attributes

  *   `denominator` (*type:* `GoogleApi.Spanner.V1.Model.LocalizedString.t`, *default:* `nil`) - The name of the denominator metric. e.g. "rows".
  *   `numerator` (*type:* `GoogleApi.Spanner.V1.Model.LocalizedString.t`, *default:* `nil`) - The name of the numerator metric. e.g. "latency".
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :denominator => GoogleApi.Spanner.V1.Model.LocalizedString.t() | nil,
          :numerator => GoogleApi.Spanner.V1.Model.LocalizedString.t() | nil
        }

  field(:denominator, as: GoogleApi.Spanner.V1.Model.LocalizedString)
  field(:numerator, as: GoogleApi.Spanner.V1.Model.LocalizedString)
end

defimpl Poison.Decoder, for: GoogleApi.Spanner.V1.Model.DerivedMetric do
  def decode(value, options) do
    GoogleApi.Spanner.V1.Model.DerivedMetric.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Spanner.V1.Model.DerivedMetric do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
