# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Spanner.V1.Model.IncludeReplicas do
  @moduledoc """
  An IncludeReplicas contains a repeated set of ReplicaSelection which indicates the order in which replicas should be considered.

  ## Attributes

  *   `autoFailoverDisabled` (*type:* `boolean()`, *default:* `nil`) - If true, Spanner will not route requests to a replica outside the include_replicas list when all of the specified replicas are unavailable or unhealthy. Default value is `false`.
  *   `replicaSelections` (*type:* `list(GoogleApi.Spanner.V1.Model.ReplicaSelection.t)`, *default:* `nil`) - The directed read replica selector.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :autoFailoverDisabled => boolean() | nil,
          :replicaSelections => list(GoogleApi.Spanner.V1.Model.ReplicaSelection.t()) | nil
        }

  field(:autoFailoverDisabled)
  field(:replicaSelections, as: GoogleApi.Spanner.V1.Model.ReplicaSelection, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.Spanner.V1.Model.IncludeReplicas do
  def decode(value, options) do
    GoogleApi.Spanner.V1.Model.IncludeReplicas.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Spanner.V1.Model.IncludeReplicas do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
