# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Spanner.V1.Model.IndexAdvice do
  @moduledoc """
  Recommendation to add new indexes to run queries more efficiently.

  ## Attributes

  *   `ddl` (*type:* `list(String.t)`, *default:* `nil`) - Optional. DDL statements to add new indexes that will improve the query.
  *   `improvementFactor` (*type:* `float()`, *default:* `nil`) - Optional. Estimated latency improvement factor. For example if the query currently takes 500 ms to run and the estimated latency with new indexes is 100 ms this field will be 5.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :ddl => list(String.t()) | nil,
          :improvementFactor => float() | nil
        }

  field(:ddl, type: :list)
  field(:improvementFactor)
end

defimpl Poison.Decoder, for: GoogleApi.Spanner.V1.Model.IndexAdvice do
  def decode(value, options) do
    GoogleApi.Spanner.V1.Model.IndexAdvice.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Spanner.V1.Model.IndexAdvice do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
