# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Spanner.V1.Model.IndexedHotKey do
  @moduledoc """
  A message representing a (sparse) collection of hot keys for specific key buckets.

  ## Attributes

  *   `sparseHotKeys` (*type:* `map()`, *default:* `nil`) - A (sparse) mapping from key bucket index to the index of the specific hot row key for that key bucket. The index of the hot row key can be translated to the actual row key via the ScanData.VisualizationData.indexed_keys repeated field.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :sparseHotKeys => map() | nil
        }

  field(:sparseHotKeys, type: :map)
end

defimpl Poison.Decoder, for: GoogleApi.Spanner.V1.Model.IndexedHotKey do
  def decode(value, options) do
    GoogleApi.Spanner.V1.Model.IndexedHotKey.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Spanner.V1.Model.IndexedHotKey do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
