# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Spanner.V1.Model.KeyRangeInfos do
  @moduledoc """
  A message representing a list of specific information for multiple key ranges.

  ## Attributes

  *   `infos` (*type:* `list(GoogleApi.Spanner.V1.Model.KeyRangeInfo.t)`, *default:* `nil`) - The list individual KeyRangeInfos.
  *   `totalSize` (*type:* `integer()`, *default:* `nil`) - The total size of the list of all KeyRangeInfos. This may be larger than the number of repeated messages above. If that is the case, this number may be used to determine how many are not being shown.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :infos => list(GoogleApi.Spanner.V1.Model.KeyRangeInfo.t()) | nil,
          :totalSize => integer() | nil
        }

  field(:infos, as: GoogleApi.Spanner.V1.Model.KeyRangeInfo, type: :list)
  field(:totalSize)
end

defimpl Poison.Decoder, for: GoogleApi.Spanner.V1.Model.KeyRangeInfos do
  def decode(value, options) do
    GoogleApi.Spanner.V1.Model.KeyRangeInfos.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Spanner.V1.Model.KeyRangeInfos do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
