# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Spanner.V1.Model.ListBackupsResponse do
  @moduledoc """
  The response for ListBackups.

  ## Attributes

  *   `backups` (*type:* `list(GoogleApi.Spanner.V1.Model.Backup.t)`, *default:* `nil`) - The list of matching backups. Backups returned are ordered by `create_time` in descending order, starting from the most recent `create_time`.
  *   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - `next_page_token` can be sent in a subsequent ListBackups call to fetch more of the matching backups.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :backups => list(GoogleApi.Spanner.V1.Model.Backup.t()) | nil,
          :nextPageToken => String.t() | nil
        }

  field(:backups, as: GoogleApi.Spanner.V1.Model.Backup, type: :list)
  field(:nextPageToken)
end

defimpl Poison.Decoder, for: GoogleApi.Spanner.V1.Model.ListBackupsResponse do
  def decode(value, options) do
    GoogleApi.Spanner.V1.Model.ListBackupsResponse.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Spanner.V1.Model.ListBackupsResponse do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
