# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Spanner.V1.Model.PartitionResponse do
  @moduledoc """
  The response for PartitionQuery or PartitionRead

  ## Attributes

  *   `partitions` (*type:* `list(GoogleApi.Spanner.V1.Model.Partition.t)`, *default:* `nil`) - Partitions created by this request.
  *   `transaction` (*type:* `GoogleApi.Spanner.V1.Model.Transaction.t`, *default:* `nil`) - Transaction created by this request.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :partitions => list(GoogleApi.Spanner.V1.Model.Partition.t()) | nil,
          :transaction => GoogleApi.Spanner.V1.Model.Transaction.t() | nil
        }

  field(:partitions, as: GoogleApi.Spanner.V1.Model.Partition, type: :list)
  field(:transaction, as: GoogleApi.Spanner.V1.Model.Transaction)
end

defimpl Poison.Decoder, for: GoogleApi.Spanner.V1.Model.PartitionResponse do
  def decode(value, options) do
    GoogleApi.Spanner.V1.Model.PartitionResponse.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Spanner.V1.Model.PartitionResponse do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
