# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Spanner.V1.Model.QueryPlan do
  @moduledoc """
  Contains an ordered list of nodes appearing in the query plan.

  ## Attributes

  *   `planNodes` (*type:* `list(GoogleApi.Spanner.V1.Model.PlanNode.t)`, *default:* `nil`) - The nodes in the query plan. Plan nodes are returned in pre-order starting with the plan root. Each PlanNode's `id` corresponds to its index in `plan_nodes`.
  *   `queryAdvice` (*type:* `GoogleApi.Spanner.V1.Model.QueryAdvisorResult.t`, *default:* `nil`) - Optional. The advices/recommendations for a query. Currently this field will be serving index recommendations for a query.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :planNodes => list(GoogleApi.Spanner.V1.Model.PlanNode.t()) | nil,
          :queryAdvice => GoogleApi.Spanner.V1.Model.QueryAdvisorResult.t() | nil
        }

  field(:planNodes, as: GoogleApi.Spanner.V1.Model.PlanNode, type: :list)
  field(:queryAdvice, as: GoogleApi.Spanner.V1.Model.QueryAdvisorResult)
end

defimpl Poison.Decoder, for: GoogleApi.Spanner.V1.Model.QueryPlan do
  def decode(value, options) do
    GoogleApi.Spanner.V1.Model.QueryPlan.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Spanner.V1.Model.QueryPlan do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
