# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Spanner.V1.Model.RequestOptions do
  @moduledoc """
  Common request options for various APIs.

  ## Attributes

  *   `priority` (*type:* `String.t`, *default:* `nil`) - Priority for the request.
  *   `requestTag` (*type:* `String.t`, *default:* `nil`) - A per-request tag which can be applied to queries or reads, used for statistics collection. Both request_tag and transaction_tag can be specified for a read or query that belongs to a transaction. This field is ignored for requests where it's not applicable (e.g. CommitRequest). Legal characters for `request_tag` values are all printable characters (ASCII 32 - 126) and the length of a request_tag is limited to 50 characters. Values that exceed this limit are truncated. Any leading underscore (_) characters will be removed from the string.
  *   `transactionTag` (*type:* `String.t`, *default:* `nil`) - A tag used for statistics collection about this transaction. Both request_tag and transaction_tag can be specified for a read or query that belongs to a transaction. The value of transaction_tag should be the same for all requests belonging to the same transaction. If this request doesn't belong to any transaction, transaction_tag will be ignored. Legal characters for `transaction_tag` values are all printable characters (ASCII 32 - 126) and the length of a transaction_tag is limited to 50 characters. Values that exceed this limit are truncated. Any leading underscore (_) characters will be removed from the string.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :priority => String.t() | nil,
          :requestTag => String.t() | nil,
          :transactionTag => String.t() | nil
        }

  field(:priority)
  field(:requestTag)
  field(:transactionTag)
end

defimpl Poison.Decoder, for: GoogleApi.Spanner.V1.Model.RequestOptions do
  def decode(value, options) do
    GoogleApi.Spanner.V1.Model.RequestOptions.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Spanner.V1.Model.RequestOptions do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
