# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Spanner.V1.Model.Session do
  @moduledoc """
  A session in the Cloud Spanner API.

  ## Attributes

  *   `approximateLastUseTime` (*type:* `DateTime.t`, *default:* `nil`) - Output only. The approximate timestamp when the session is last used. It is typically earlier than the actual last use time.
  *   `createTime` (*type:* `DateTime.t`, *default:* `nil`) - Output only. The timestamp when the session is created.
  *   `creatorRole` (*type:* `String.t`, *default:* `nil`) - The database role which created this session.
  *   `labels` (*type:* `map()`, *default:* `nil`) - The labels for the session. * Label keys must be between 1 and 63 characters long and must conform to the following regular expression: `[a-z]([-a-z0-9]*[a-z0-9])?`. * Label values must be between 0 and 63 characters long and must conform to the regular expression `([a-z]([-a-z0-9]*[a-z0-9])?)?`. * No more than 64 labels can be associated with a given session. See https://goo.gl/xmQnxf for more information on and examples of labels.
  *   `multiplexed` (*type:* `boolean()`, *default:* `nil`) - Optional. If true, specifies a multiplexed session. A multiplexed session may be used for multiple, concurrent read-only operations but can not be used for read-write transactions, partitioned reads, or partitioned queries. Multiplexed sessions can be created via CreateSession but not via BatchCreateSessions. Multiplexed sessions may not be deleted nor listed.
  *   `name` (*type:* `String.t`, *default:* `nil`) - Output only. The name of the session. This is always system-assigned.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :approximateLastUseTime => DateTime.t() | nil,
          :createTime => DateTime.t() | nil,
          :creatorRole => String.t() | nil,
          :labels => map() | nil,
          :multiplexed => boolean() | nil,
          :name => String.t() | nil
        }

  field(:approximateLastUseTime, as: DateTime)
  field(:createTime, as: DateTime)
  field(:creatorRole)
  field(:labels, type: :map)
  field(:multiplexed)
  field(:name)
end

defimpl Poison.Decoder, for: GoogleApi.Spanner.V1.Model.Session do
  def decode(value, options) do
    GoogleApi.Spanner.V1.Model.Session.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Spanner.V1.Model.Session do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
