# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Spanner.V1.Model.UpdateInstanceConfigMetadata do
  @moduledoc """
  Metadata type for the operation returned by UpdateInstanceConfig.

  ## Attributes

  *   `cancelTime` (*type:* `DateTime.t`, *default:* `nil`) - The time at which this operation was cancelled.
  *   `instanceConfig` (*type:* `GoogleApi.Spanner.V1.Model.InstanceConfig.t`, *default:* `nil`) - The desired instance config after updating.
  *   `progress` (*type:* `GoogleApi.Spanner.V1.Model.InstanceOperationProgress.t`, *default:* `nil`) - The progress of the UpdateInstanceConfig operation.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :cancelTime => DateTime.t() | nil,
          :instanceConfig => GoogleApi.Spanner.V1.Model.InstanceConfig.t() | nil,
          :progress => GoogleApi.Spanner.V1.Model.InstanceOperationProgress.t() | nil
        }

  field(:cancelTime, as: DateTime)
  field(:instanceConfig, as: GoogleApi.Spanner.V1.Model.InstanceConfig)
  field(:progress, as: GoogleApi.Spanner.V1.Model.InstanceOperationProgress)
end

defimpl Poison.Decoder, for: GoogleApi.Spanner.V1.Model.UpdateInstanceConfigMetadata do
  def decode(value, options) do
    GoogleApi.Spanner.V1.Model.UpdateInstanceConfigMetadata.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Spanner.V1.Model.UpdateInstanceConfigMetadata do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
